/** Demonstrates a class loader implementation for use with Java 1.2.
*/
public class CustomLoader2 extends java.lang.ClassLoader
{
	/** Required method. Called from the parent class loadClass() if the class was not 
	found in the cache, and couldn't be loaded by the system loader.  Notice how 
	findClass is not responsible for loading any system classes like class loaders 
	for Java 1.1.
	*/
    public Class findClass(String name) throws ClassNotFoundException
    {
        CustomClassLoader	borrowedLoader = new CustomClassLoader();
        byte[]				classData;
        Class				newClass;
        
        /* Use CustomClassLoader to read the class data */
        classData = borrowedLoader.readClassFile(name);
        if (classData == null) {
        	throw new ClassNotFoundException();
        }
        newClass = defineClass(name, classData, 0, classData.length);
        System.out.println("Class " + newClass.getName() + " loaded by CustomLoader2");
        return newClass;
    }
    
	/** Not required.  Just put this here to watch the class loading process.
	*/
	public synchronized Class loadClass(String name, boolean resolve) throws ClassNotFoundException
	{
		System.out.println("Loading class " + name);
		return super.loadClass(name, resolve);
	}

} // CustomLoader2
