import java.lang.*;
import java.io.*;
import emJava20.emCore.*;
import emJava20.emClient.*;


public class DeviceConnection
{
	final String	kProgramVar = "em_StorageArray";
	
	Emitjri			mEmit;
	EmitIO			mEmitIO;	// handles synchronized IO with Emitjri
	
	
	public DeviceConnection() {
		mEmit = new Emitjri();
		mEmitIO = new EmitIO();
	}
	
	
	public void connect() {
		mEmit.connect(emComUtils.initTCP("http://broelofs/smlink0/"));
		if ( mEmit.isConnected() ) {
			System.out.println("Connected");
		}
		else {
			System.out.println("Couldn't connect");
		}
	}
	
	
	public byte[] getProgramArray() {
		byte[]		programArray = null;
		int[]		variableArray;
		
		try {
			variableArray = (int[])mEmitIO.getEmitVariable(mEmit, kProgramVar);
			programArray = new byte[variableArray.length];
			for (int n = 0; n < variableArray.length; n++) {
				programArray[n] = (byte)variableArray[n];
			}
			System.out.println("Program read complete");
			variableArray = null;
		}
		catch (NullObjectException e) {
			System.out.println( e.toString() );
			e.printStackTrace();
		}
		return programArray;
	}
	
	
	public void setProgramArray() {
		byte[]				inputBytes;
		int					bytesRead = 0;
		File				classFile = new File(".\\TestClassOutPut\\TestClass.class");
		FileInputStream		fileStream = null;
		
		/* Read the file in one shot into a buffer and write it to the device storage. */
		try {
			fileStream = new FileInputStream(classFile);
			
			/* Create a buffer big enough to hold the entire class file. */
			bytesRead = (int)classFile.length();
			inputBytes = new byte[bytesRead];
			
			/* Read the class file and write it to the device storage. */
			try {
				bytesRead = fileStream.read(inputBytes);
				mEmitIO.setEmitVariable(mEmit, kProgramVar, inputBytes, emType.BYTE_ARRAY);
			}
			catch (IOException e) {
				System.out.println("Exception trying to read the class file");
			}
		}
		catch (FileNotFoundException e) {
			System.out.println("File " + classFile.toString() + " doesn't exist");	
		}
		
	}
	
} // DeviceConnection